/*
 * clisp.h
 */
/*
 * Copyright (C) 2000,2002  Hirotsugu Kakugawa. 
 * All rights reserved.
 *
 * This file is part of the VFlib Library.  This library is free
 * software; you can redistribute it and/or modify it under the terms of
 * the GNU Library General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your
 * option) any later version.  This library is distributed in the hope
 * that it will be useful, but WITHOUT ANY WARRANTY; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU Library General Public License for more details.
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

typedef long     vf_sexp;

extern void     vf_lisp_engine_new(VF_Engine);
extern void     vf_lisp_engine_delete(VF_Engine);

extern void     vf_lisp_toplevel(VF_Engine);
extern vf_sexp  vf_lisp_read_file(VF_Engine,FILE*);
extern vf_sexp  vf_lisp_read_string(VF_Engine,char*);

extern void     vf_lisp_gc(VF_Engine);
extern int      vf_lisp_gc_protect(VF_Engine,vf_sexp);
extern void     vf_lisp_gc_unprotect(VF_Engine,int);
extern void     vf_lisp_gc_unprotect_all(VF_Engine);

extern vf_sexp  vf_lisp_intern(VF_Engine,char*);
extern vf_sexp  vf_lisp_setq(VF_Engine,vf_sexp,vf_sexp);
extern vf_sexp  vf_lisp_symb_val(VF_Engine,vf_sexp);
extern vf_sexp  vf_lisp_eval(VF_Engine,vf_sexp);
extern vf_sexp  vf_lisp_print(VF_Engine,vf_sexp);
extern vf_sexp  vf_lisp_terpri(VF_Engine);

extern int      vf_lisp_null(VF_Engine,vf_sexp);
extern int      vf_lisp_nilp(VF_Engine,vf_sexp);
extern int      vf_lisp_tp(VF_Engine,vf_sexp);
extern int      vf_lisp_eofp(VF_Engine,vf_sexp);
extern int      vf_lisp_symbolp(VF_Engine,vf_sexp);
extern int      vf_lisp_numberp(VF_Engine,vf_sexp);
extern int      vf_lisp_integerp(VF_Engine,vf_sexp);
extern int      vf_lisp_floatp(VF_Engine,vf_sexp);
extern int      vf_lisp_consp(VF_Engine,vf_sexp);
extern int      vf_lisp_listp(VF_Engine,vf_sexp);
extern int      vf_lisp_length(VF_Engine,vf_sexp);
extern int      vf_lisp_alistp(VF_Engine,vf_sexp);
extern vf_sexp  vf_lisp_assoc(VF_Engine,char*,vf_sexp);
extern int      vf_lisp_eq(VF_Engine,vf_sexp,vf_sexp);
extern int      vf_lisp_equal(VF_Engine,vf_sexp,vf_sexp);

extern char*    vf_lisp_get_cstring(VF_Engine,vf_sexp);
extern int      vf_lisp_get_cint(VF_Engine,vf_sexp);
extern double   vf_lisp_get_cnumber(VF_Engine,vf_sexp);
extern vf_sexp  vf_lisp_nil(VF_Engine);

extern vf_sexp  vf_lisp_cons(VF_Engine,vf_sexp,vf_sexp);
extern vf_sexp  vf_lisp_car(VF_Engine,vf_sexp);
extern vf_sexp  vf_lisp_cdr(VF_Engine,vf_sexp);
extern vf_sexp  vf_lisp_caar(VF_Engine,vf_sexp);
extern vf_sexp  vf_lisp_cadr(VF_Engine,vf_sexp);
extern vf_sexp  vf_lisp_cdar(VF_Engine,vf_sexp);
extern vf_sexp  vf_lisp_cddr(VF_Engine,vf_sexp);
extern void     vf_lisp_rplaca(VF_Engine,vf_sexp,vf_sexp);
extern void     vf_lisp_rplacd(VF_Engine,vf_sexp,vf_sexp);

extern int      vf_lisp_vectorp(VF_Engine,vf_sexp);
extern vf_sexp  vf_lisp_vector_ref(VF_Engine,vf_sexp,int);
extern int      vf_lisp_vector_length(VF_Engine,vf_sexp);

extern int      vf_lisp_stringp(VF_Engine,vf_sexp);
extern char*    vf_lisp_string(VF_Engine,vf_sexp);
extern int      vf_lisp_string_length(VF_Engine,vf_sexp);

